/* main.h */
/* version 0.6 */
/* fichier pour le linker K2->C */
/* Rgis Cridlig 1991-1994 */

#include "./sys.h"

#ifndef BOEHM
/**********************************************************************
 * Parametres de la gestion memoire (cf parametres.h)
 **********************************************************************/

double  ExpansionFactor = EXPANSION_FACTOR;
npage_t MinExpansion =    MINIMUM_EXPANSION;
npage_t GCThreshold =     GCTHRESHOLD;
npage_t InitialNPages =   INITIAL_NPAGES;
extern void *usrstack;
# ifdef MONITOR_GC
extern int _gc_monitor_time;
extern int _gc_monitor_locality;
# endif

/* Variables globales */

#define MAXGCVARS 5000   /* a augmenter s'il le faut */
int NGcVars=0;             /* nb variables a visiter */
obj_t *GcVars[MAXGCVARS];         /* tableau initial des racines */

#endif

#ifdef NOGC
obj_t freep;
#endif

obj_t __ContinueValue, __0handle__0, __0try__0;
obj_t constants[256]; 
/* constants[0] & constants[1] servent aussi pour la chaine de 
   caracteres et le vecteur vides respectivement */
	
extern obj_t io__exit__01(obj_t);
extern obj_t really_write(int,char*,int);
extern obj_t string_of_tag(obj_t);

void main(int argc,char *argv[])
{ int i;
  jmp_buf buf;

#ifdef BOEHM
# ifdef NOGC
  freep=(obj_t)malloc(20000000);
# else
  GC_dont_expand=1;
# endif
#else

# ifdef MONITOR_GC  
  _gc_monitor_time = 1;
  _gc_monitor_locality = 0;
# endif

  usrstack = (val_t)&buf;  /* fond de pile */
# ifdef MONITOR_GC
   _report_execution_begins(argv[0]);
# endif
/* variables ML visibles depuis C pouvant contenir des pointeurs racines */
    GcVars[NGcVars++]=&sys_command_line;
    gcvars();
    if (NGcVars>MAXGCVARS)
      { really_write(2,"NGcVars>MAXGCVARS\n",18);
	exit(1);
      }
    InitMemoryManager(InitialNPages);   /* initialize memory manager */
# ifdef MONITOR_GC
    _report_init_heap();
# endif
#endif

  for (i=0;i<256;i++) constants[i]=MLINT(i);
  sys_init(argc,argv);

  __0try__0=MLINT(0);
  if (setjmp(buf))
  { char s[200];
    obj_t tag = TAGORIMM(__ContinueValue);

    really_write(2,"fatal error in main: uncaught exception ",40);
    sprintf(s,"%d (%s)\n",CINT(tag),STRING(string_of_tag(tag)));
    really_write(2,s,strlen(s));
    io__exit__01(MLINT(1));
  }
  else { __0handle__0=KCONT(buf);
	 objects();
	 io__exit__01(MLINT(0)); /* pour flusher les buffers */
       }
}
